com.collabnet.ce.soap60.webservices.tracker

## Interface ITrackerAppSoap

- All Known Implementing Classes:
    TrackerAppSoapMockStub, TrackerAppSoapStub

      public interface ITrackerAppSoap

  Provides SOAP services for managing user trackers and artifacts.
  Change History
  Version 18.1
  - Modified to ignore the time portion of the custom Date field's value.
  Version 17.11
  - getAllowedWorkflowTransitionList3 New method to retrieve workflow transition list with auto populate fields
  Version 17.8
  - getAllowedWorkflowTransitionList2 New method to retrieve workflow transition list with hidden fields
  Version 17.4
  - getArtifactData3 New method to retrieve artifact with tags
  - setArtifactData4 New method to support editing artifact with tags
  - createArtifact4 New method to support creating artifact with tags
  Version 16.7
  - getFields2 New method, to get the filtered field roles in the 'assignedTo' field of tracker field
  - setField2 New method, to set the filtered field roles into the tracker field
  Version 8.0
  - copyWorkflowTransitions Updated this method to copy workflow transitions between two trackers including global roles
  - getArtifactList2 New method, to retrieve list of artifacts with autoSummingPoints and Team field Information
  - setArtifactData3 New method, to support set Artifact Data with autoSummingPoints and Team field
  - createArtifact3 New method, to support create Artifact with autoSummingPoints and Team field
  - getArtifactData2 New method, to retrieve artifact with autoSummingPoints and Team field Information
  - moveArtifact2 New method, move artifact with autoSummingPoints and Team field support
  - getCrossTrackerArtifactList2 New method, to retrieve list of cross tracker artifacts with autoSummingPoints and Team field support
  - findArtifacts2 New method, to retrieve list artifacts that matches given string
  - getArtifactDetailList2 New method, to retrieve list of artifacts in detailed format
  - cloneTracker New method, to create a clone Tracker with in the same project
  - cloneTrackerAcrossProject New method, to create a clone Tracker across the project
  - createTracker3 New method, to create a tracker with autosum foreign children support
  - setTracker3Data New method, to update a tracker with autosum foreign children support
  - getTracker3Data New method, to retrieve a tracker with autosum foreign children support
  - getTracker3List New method, to retrieve a tracker list with autosum foreign children support

  Version 6.2
  - setArtifactData2 New method, to support set Artifact Data with multiple attachments, added in 6.2
  - createArtifact2 New method, to support create Artifact with multiple attachments, added in 6.2
  - getUnitsByProject New method, to retrieve the units for a given project, added in 6.2
  - createTracker2 New method, to create a tracker with the tracker unit, added in 6.2
  - getTracker2Data New method, to retrieve a tracker with the tracker unit, added in 6.2
  - setTracker2Data New method, to update a tracker with the tracker unit, added in 6.2
  - getTracker2List New method, to retrieve a tracker list with the tracker unit, added in 6.2

  Version 6.1
  - getTracker2List: Removed and merged into getTrackerList.
  - getTracker2Data: Removed and merged into getTrackerData.
  - setTracker2Data: Removed and merged into setTrackerData.
  - createTracker2: Removed and merged into createTracker.
  - setField3, setField2: Removed and merged into setField.
  - getFields3, getFields2: Removed and merged into getFields.
  - addTextField2: Removed and merged into addTextField.
  - addSingleSelectField2: Removed and merged into addSingleSelectField.
  - addMultiSelectField2: Removed and merged into addMultiSelectField.
  - addUserSelectField2: Removed and merged into addUserSelectField.
  - addDateField2: Removed and merged into addDateField.
  - getArtifactList3, getArtifactList2: Removed and merged into getArtifactList.
  - getArtifactDetailList3, getArtifactDetailList2: Removed and merged into getArtifactDetailList.
  - findArtifacts3, findArtifacts2: Removed and merged into findArtifacts.
  - getArtifactData3, getArtifactData2: Removed and merged into getArtifactData.
  - setArtifactData3, setArtifactData2: Removed and merged into setArtifactData.
  - moveArtifact3, moveArtifact2: Removed and merged into moveArtifact.
  - copyWorkflowTransitions2: Removed and merged into copyWorkflowTransitions.
  - getChildDependency2List: Removed and merged into getChildDependencyList.
  - getParentDependency2List: Removed and merged into getParentDependencyList.
  - createArtifact3, createArtifact2: Removed and merged into createArtifact.
  - getCrossTrackerArtifactList2: Removed and merged into getCrossTrackerArtifactList.

  Version 5.4.1
  - setField3: Added to 5.4.1 to accommodate new help text, pattern fields and field hierarchy.
  - addTextField2: Added to 5.4.1 to accommodate new help text and pattern fields.
  - addSingleSelectField2: Added to 5.4.1 to accommodate new help text field.
  - addSingleSelectChildField: Added to 5.4.1 to create single select field specifying its parent.
  - addMultiSelectField2: Added to 5.4.1 to accommodate new help text field.
  - addUserSelectField2: Added to 5.4.1 to accommodate new help text field.
  - addDateField2: Added to 5.4.1 to accommodate new help text field.
  - getFields3: Added to 5.4.1 to accommodate new help text, pattern fields and field hierarchy.
  - addSeparator: Added to 5.4.1 to add a separator in a tracker.
  - deleteSeparator: Added to 5.4.1 to delete a separator in a tracker.
  - getOrderedTrackerFields: Added to 5.4.1 to get ordered list of fields and separators in a tracker.
  - reorderTrackerFields: Added to 5.4.1 to reorder list of fields and separators in a tracker.

  Version 5.4
  - reorderTrackers: Added to 5.4 to reorder the way the trackers are displayed.
  - setArtifactRank: Added to 5.4 to rank artifacts in a planning folder.
  - createArtifact3: Added to 5.4 to accommodate new points field.
  - getArtifactData3: Added to 5.4 to accommodate new points field.
  - setArtifactData3: Added to 5.4 to accommodate new points field.
  - moveArtifacts3: Added to 5.4 to accommodate new points field.
  - getArtifactList3: Added to 5.4 to accommodate new points field.
  - getArtifactDetailList3: Added to 5.4 to accommodate new points field and to support filtering on the release fields.
  - findArtifacts3: Added to 5.4 to accommodate new points field.
  - getCrossTrackerArtifactList2: Added to 5.4 to accommodate new points field.

  Version 5.3
  - createTracker2: Added back in 5.3 to return new `Tracker2Soap` objects.
  - getTracker2Data: Added back in 5.3 to return new `Tracker2Soap` objects.
  - setTracker2Data: Added back in 5.3 work with new `Tracker2Soap` objects.
  - getTracker2List: Added back in 5.3 work with new `Tracker2SoapList` objects.
  - getCrossTrackerArtifactList: Added in 5.3 to return new `ArtifactDetail2SoapList` objects.
  - getArtifactDetailList2: Added back in 5.3 to return new `ArtifactDetail2SoapList` objects.
  - getChildDependency2List: Added back in 5.3 to return new `TrackerArtifactDependency2List`.
  - getParentDependency2List: Added back in 5.3 to return new `TrackerArtifactDependency2List`.
  - getArtifactList2: Added back in 5.3 to return new `Artifact2SoapList` objects.
  - createArtifact2: Added back in 5.3 to accommodate new effort fields.
  - getArtifactData2: Added back in 5.3 to return new `Artifact2SoapDO` object.
  - setArtifactData2: Added back in 5.3 to work with new `Artifact2SoapDO` objects.
  - setField2: Added back in 5.3 to work with new `TrackerField2SoapDO` objects.
  - getFields2: Added back in 5.3 to work with new `TrackerField2SoapDO` objects.
  - copyWorkflowTransitions2: Added to 5.3.
  - findArtifacts2: Added to 5.3 to return new `Artifact2SoapDO` objects.
  - moveArtifacts2: Added to 5.3 to work with new `Artifact2SoapDO` objects.
  - All methods taking SoapFilter
  arguments now support ORing filter conditions if multiple SoapFilter objects with the same name but different values are passed.
- New filter constants Artifact2SoapDO.FILTER_PLANNING_FOLDER_ID, Artifact2SoapDO.FILTER_MODIFIED_BEFORE, Artifact2SoapDO.FILTER_MODIFIED_AFTER, Artifact2SoapDO.FILTER_SUBMITTED_BEFORE, Artifact2SoapDO.FILTER_SUBMITTED_AFTER, Artifact2SoapDO.FILTER_CUSTOMER, Artifact2SoapDO.FILTER_GROUP, Artifact2SoapDO.FILTER_TITLE, Artifact2SoapDO.FILTER_REPORTED_IN_RELEASE_TITLE, Artifact2SoapDO.FILTER_RESOLVED_IN_RELEASE_TITLE, Artifact2SoapDO.FILTER_REMAINING_EFFORT Artifact2SoapDO.FILTER_ACTUAL_EFFORT, Artifact2SoapDO.FILTER_ESTIMATED_EFFORT and Artifact2SoapDO.FILTER_AUTOSUMMING.
- New column constants Artifact2SoapDO.COLUMN_PLANNING_FOLDER_ID, Artifact2SoapDO.COLUMN_PLANNING_FOLDER_TITLE, Artifact2SoapDO.COLUMN_ESTIMATED_EFFORT, Artifact2SoapDO.COLUMN_REMAINING_EFFORT, Artifact2SoapDO.COLUMN_ACTUAL_EFFORT and Artifact2SoapDO.COLUMN_AUTOSUMMING

Version 4.4 SP 1

- getAllowedWorkflowTransitionList: Added the missing [new artifact] transitions to the list

Version 4.4

- getFields2: Removed in 4.4. Changes were incorporated into getFields
- setField2: Removed in 4.4. Changes were incorporated into setField
- getArtifactDetailList2: Removed in 4.4. Changes were incorporated into getArtifactDetailList, in addition to the incorporation of new features (paged data return, selection of returned columns, and sorted results).
- createArtifact2: Removed in 4.4. Changes were incorporated into createArtifact
- getArtifactData2: Removed in 4.4. Changes were incorporated into getArtifactData
- setArtifactData2: Removed in 4.4. Changes were incorporated into setArtifactData
- setField: New exception added in 4.4: DependencyViolationFault
- getArtifactList: Added a limit to the number of rows that could be retrieved. This limit is by default 5000 but is configurable

- getChildDependencyList: New operation added in 4.4
- createArtifactDependency: New operation added in 4.4
- getParentdDependencyList: New operation added in 4.4
- removeArtifactDependency: New operation added in 4.4

Since:
  4.1

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addDateField(String sessionId, String trackerId, String fieldName, boolean isRequired, boolean isDisabled, boolean isHiddenOnCreate, String helpText)` Adds a custom Date field to a tracker.
    `void` | `addMultiSelectField(String sessionId, String trackerId, String fieldName, int displayLines, boolean isRequired, boolean isDisabled, boolean isHiddenOnCreate, String[] fieldValues, String[] defaultValues, String helpText)` Adds a custom multi select field to a tracker.
    `void` | `addSeparator(String sessionId, String trackerId, String separatorType, String separatorLabel)` Adds a separator to a tracker.
    `void` | `addSingleSelectChildField(String sessionId, String trackerId, String fieldName, String[] fieldValues, String parentFieldId, com.collabnet.ce.soap60.types.SoapNamedValues parentChildFieldValueMap, String helpText)` Adds a custom single select field to a tracker.
    `void` | `addSingleSelectField(String sessionId, String trackerId, String fieldName, boolean isRequired, boolean isDisabled, boolean isHiddenOnCreate, String[] fieldValues, String defaultValue, String helpText)` Adds a custom single select field to a tracker.
    `void` | `addTextField(String sessionId, String trackerId, String fieldName, int displayColumns, int displayLines, boolean isRequired, boolean isDisabled, boolean isHiddenOnCreate, String defaultValue, String helpText, String pattern)` Adds a custom text field to a tracker.
    `void` | `addUserSelectField(String sessionId, String trackerId, String fieldName, int displayLines, boolean isRequired, boolean isDisabled, boolean isHiddenOnCreate, String[] defaultValues, String userFilter, String helpText)` Adds a custom User selection field to a tracker.
    `Tracker2SoapDO` | `cloneTracker(String sessionId, String srcTrackerId, String destTrackerTitle, String destTrackerDescription)` Clone Tracker within the same project
    `Tracker2SoapDO` | `cloneTrackerAcrossProject(String sessionId, String srcTrackerId, String destProjectId, String destTrackerTitle, String destTrackerDescription)` Clone Tracker across the project
    `void` | `copyWorkflowTransitions(String sessionId, String srcTrackerId, String dstTrackerId)` Copies workflow transitions between two trackers.
    `ArtifactSoapDO` | `createArtifact(String sessionId, String trackerId, String title, String description, String group, String category, String status, String customer, int priority, int estimatedEffort, int remainingEffort, boolean autosumming, int points, String assignedUsername, String releaseId, String planningFolderId, com.collabnet.ce.soap60.types.SoapFieldValues flexFields, String attachmentFileName, String attachmentMimeType, String attachmentFileId)` Deprecated. in favor of createArtifact4
    `ArtifactSoapDO` | `createArtifact2(String sessionId, String trackerId, String title, String description, String group, String category, String status, String customer, int priority, int estimatedEffort, int remainingEffort, boolean autosumming, int points, String assignedUsername, String releaseId, String planningFolderId, com.collabnet.ce.soap60.types.SoapFieldValues flexFields, AttachmentSoapDO[] attachments)` Deprecated. in favor of createArtifact4
    `Artifact2SoapDO` | `createArtifact3(String sessionId, String trackerId, String title, String description, String group, String category, String status, String customer, int priority, int estimatedEffort, int remainingEffort, boolean autosumming, int points, boolean autoSummingPoints, String assignedUsername, String releaseId, String planningFolderId, String teamId, com.collabnet.ce.soap60.types.SoapFieldValues flexFields, AttachmentSoapDO[] attachments)` Deprecated. in favor of createArtifact4
    `Artifact3SoapDO` | `createArtifact4(String sessionId, String trackerId, String title, String description, String group, String category, String status, String customer, int priority, int estimatedEffort, int remainingEffort, boolean autosumming, int points, boolean autoSummingPoints, String assignedUsername, String releaseId, String planningFolderId, String teamId, com.collabnet.ce.soap60.types.SoapFieldValues flexFields, AttachmentSoapDO[] attachments, String[] tagNames)` Creates a new artifact with multiple attachments, flag to enable the autosumming_points and tags.
    `void` | `createArtifactDependency(String sessionId, String originId, String targetId, String desc)` Creates an artifact dependency between two artifacts.
    `TrackerSoapDO` | `createTracker(String sessionId, String projectId, String trackerName, String trackerTitle, String trackerDescription, String icon)` Deprecated. use createTracker3 instead, which includes tracker unit and autosum foreign children support
    `Tracker2SoapDO` | `createTracker2(String sessionId, String projectId, String trackerName, String trackerTitle, String trackerDescription, String icon, String trackerUnitId)` Deprecated. use createTracker3 instead, which includes foreign children support
    `Tracker3SoapDO` | `createTracker3(String sessionId, String projectId, String trackerName, String trackerTitle, String trackerDescription, String icon, String trackerUnitId, boolean autosumForeignChildren)` Creates a new tracker with autosum foreign children support
    `void` | `deleteArtifact(String sessionId, String artifactId)` Deletes an artifact.
    `void` | `deleteField(String sessionId, String objectId, String fieldId)` Deletes a custom/flex-field .
    `void` | `deleteSeparator(String sessionId, String trackerId, String layoutId)` Deletes a separator of a tracker layout.
    `ArtifactSoapList` | `findArtifacts(String sessionId, String queryString, String projectId, boolean searchAttachments)` Deprecated. in favor of findArtifacts2
    `Artifact2SoapList` | `findArtifacts2(String sessionId, String queryString, String projectId, boolean searchAttachments)` Finds a list of artifacts matching a search string.
    `WorkflowTransitionSoapList` | `getAllowedWorkflowTransitionList(String sessionId, String trackerId)` Deprecated. in favor of getAllowedWorkflowTransitionList2
    `WorkflowTransition2SoapList` | `getAllowedWorkflowTransitionList2(String sessionId, String trackerId)` Deprecated. in favor of getAllowedWorkflowTransitionList3
    `WorkflowTransition3SoapList` | `getAllowedWorkflowTransitionList3(String sessionId, String trackerId)` Gets workflow transitions for the tracker.
    `ArtifactSoapDO` | `getArtifactData(String sessionId, String artifactId)` Deprecated. in favor of getArtifactData3
    `Artifact2SoapDO` | `getArtifactData2(String sessionId, String artifactId)` Deprecated. in favor of getArtifactData3
    `Artifact3SoapDO` | `getArtifactData3(String sessionId, String artifactId)` Returns data associated with the specified artifact.
    `ArtifactDetailSoapList` | `getArtifactDetailList(String sessionId, String trackerId, String[] selectedColumns, com.collabnet.ce.soap60.types.SoapFilter[] filters, com.collabnet.ce.soap60.types.SoapSortKey[] sortKeys, int startIndex, int maxRows, boolean exceptionIfExpiredCache, boolean forceNewQuery)` Deprecated. in favor of getArtifactDetailList2
    `ArtifactDetail2SoapList` | `getArtifactDetailList2(String sessionId, String trackerId, String[] selectedColumns, com.collabnet.ce.soap60.types.SoapFilter[] filters, com.collabnet.ce.soap60.types.SoapSortKey[] sortKeys, int startIndex, int maxRows, boolean exceptionIfExpiredCache, boolean forceNewQuery)` Returns a filtered and ordered list of artifacts from the specified tracker.
    `ArtifactSoapList` | `getArtifactList(String sessionId, String containerId, com.collabnet.ce.soap60.types.SoapFilter[] filters)` Deprecated. in fovor of getArtifactList2
    `Artifact2SoapList` | `getArtifactList2(String sessionId, String containerId, com.collabnet.ce.soap60.types.SoapFilter[] filters)` Returns a filtered list of artifacts within the specified container (project or tracker).
    `ArtifactDependencySoapList` | `getChildDependencyList(String sessionId, String artifactId)` Gets the dependency list for an artifact where the artifact is the origin artifact.
    `ArtifactDetailSoapList` | `getCrossTrackerArtifactList(String sessionId, String containerId, com.collabnet.ce.soap60.types.SoapFilter[] filters, String[] selectedColumns)` Deprecated. in favor of getCrossTrackerArtifactList2
    `ArtifactDetail2SoapList` | `getCrossTrackerArtifactList2(String sessionId, String containerId, com.collabnet.ce.soap60.types.SoapFilter[] filters, String[] selectedColumns)` Returns a filtered list of artifacts within the specified container (project or tracker).
    `TrackerFieldSoapDO[]` | `getFields(String sessionId, String trackerId)` Deprecated. use getFields2 instead
    `TrackerField2SoapDO[]` | `getFields2(String sessionId, String trackerId)` Returns the custom/flex-fields associated with a specific tracker.
    `OrderedTrackerFieldSoapList` | `getOrderedTrackerFields(String sessionId, String trackerId)` Returns all fields and separators in the given tracker with layout information.
    `ArtifactDependencySoapList` | `getParentDependencyList(String sessionId, String artifactId)` Gets the dependency list for an artifact where the artifact is the target artifact.
    `Tracker2SoapDO` | `getTracker2Data(String sessionId, String trackerId)` Deprecated. use getTracker3Data instead, which includes autosum foreign children support
    `Tracker2SoapList` | `getTracker2List(String sessionId, String projectId)` Deprecated. use getTracker3List instead, which includes autosum foreign children support
    `Tracker3SoapDO` | `getTracker3Data(String sessionId, String trackerId)` Returns a data object for a given tracker
    `Tracker3SoapList` | `getTracker3List(String sessionId, String projectId)` Returns a list of trackers for a project in the order that they are displayed in the UI.
    `TrackerSoapDO` | `getTrackerData(String sessionId, String trackerId)` Deprecated. use getTracker3Data instead, which includes tracker unit and autosum foreign children support
    `TrackerSoapList` | `getTrackerList(String sessionId, String projectId)` Deprecated. use getTracker3List instead, which includes tracker unit and autosum foreign children support
    `TrackerUnitSoapList` | `getUnitsByProject(String sessionId, String projectId)` Gets the units for a given project.
    `ArtifactSoapDO` | `moveArtifact(String sessionId, String artifactId, String targetFolderId, String newAssignee)` Deprecated. in favor of moveArtifact2
    `Artifact2SoapDO` | `moveArtifact2(String sessionId, String artifactId, String targetFolderId, String newAssignee)` Moves an artifact to a specified target folder.
    `void` | `removeArtifactDependency(String sessionId, String originId, String targetId)` Removes an artifact dependency between two artifacts.
    `void` | `reorderTrackerFields(String sessionId, String trackerId, String[] layoutIds)` Sets a new order of the fields and the separators within a tracker.
    `void` | `reorderTrackers(String sessionId, String[] trackerIds)` Sets a new order of the trackers within a project.
    `void` | `setArtifactData(String sessionId, ArtifactSoapDO artifactData, String comment, String attachmentFileName, String attachmentMimeType, String attachmentFileId)` Deprecated. in favor of setArtifactData4
    `void` | `setArtifactData2(String sessionId, ArtifactSoapDO artifactData, String comment, AttachmentSoapDO[] attachments)` Deprecated. in favor of setArtifactData4
    `void` | `setArtifactData3(String sessionId, Artifact2SoapDO artifactData, String comment, AttachmentSoapDO[] attachments)` Deprecated. in favor of setArtifactData4
    `void` | `setArtifactData4(String sessionId, Artifact3SoapDO artifactData, String comment, AttachmentSoapDO[] attachments)` Sets data associated along with multiple attachments with the specified artifact.
    `void` | `setArtifactRank(String sessionId, String planningFolderId, String artfToRankId, String artfBeforeId, String artfAfterId)` Sets the rank of an artifact relative to one or more other artifacts, in the context of a specific planning folder.
    `void` | `setField(String sessionId, String objectId, TrackerFieldSoapDO fieldData)` Deprecated. use setField2 instead
    `void` | `setField2(String sessionId, String objectId, TrackerField2SoapDO fieldData)` Sets a custom/flex-field that is associated with a specific folder (e.g. tracker).
    `void` | `setTracker2Data(String sessionId, Tracker2SoapDO trackerData)` Deprecated. use setTracker3Data instead, which includes autosum foreign children support
    `void` | `setTracker3Data(String sessionId, Tracker3SoapDO trackerData)` Sets data on a specific tracker with autosum foreign children support
    `void` | `setTrackerData(String sessionId, TrackerSoapDO trackerData)` Deprecated. use setTracker3Data instead, which includes tracker unit and autosum foreign children support

- - ### Method Detail

    - #### getTrackerList

          TrackerSoapList getTrackerList(String sessionId,
                                         String projectId)
                                  throws RemoteException

      Deprecated. use getTracker3List instead, which includes tracker unit and autosum foreign children support
      Returns a list of trackers for a project in the order that they are displayed in the UI.
      Parameters:
        `sessionId` - User session id.
        `projectId` - Project id.
      Returns:
        List of trackers within the project.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`
      Since:
        4.1

    - #### getTracker2List

          Tracker2SoapList getTracker2List(String sessionId,
                                           String projectId)
                                    throws RemoteException

      Deprecated. use getTracker3List instead, which includes autosum foreign children support
      Returns a list of trackers for a project in the order that they are displayed in the UI.
      Parameters:
        `sessionId` - User session id.
        `projectId` - Project id.
      Returns:
        List of trackers within the project.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`
      Since:
        6.2

    - #### getTracker3List

          Tracker3SoapList getTracker3List(String sessionId,
                                           String projectId)
                                    throws RemoteException

      Returns a list of trackers for a project in the order that they are displayed in the UI.
      Parameters:
        `sessionId` - User session id.
        `projectId` - Project id.
      Returns:
        List of trackers within the project.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`
      Since:
        8.0

    - #### getTrackerData

          TrackerSoapDO getTrackerData(String sessionId,
                                       String trackerId)
                                throws RemoteException

      Deprecated. use getTracker3Data instead, which includes tracker unit and autosum foreign children support
      Returns a data object for a given tracker
      Parameters:
        `sessionId` - User session id.
        `trackerId` - Tracker id.
      Returns:
        Detailed data on the tracker.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`
      Since:
        "4.2"

    - #### getTracker2Data

          Tracker2SoapDO getTracker2Data(String sessionId,
                                         String trackerId)
                                  throws RemoteException

      Deprecated. use getTracker3Data instead, which includes autosum foreign children support
      Returns a data object for a given tracker
      Parameters:
        `sessionId` - User session id.
        `trackerId` - Tracker id.
      Returns:
        Detailed data on the tracker.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`
      Since:
        "6.2"

    - #### getTracker3Data

          Tracker3SoapDO getTracker3Data(String sessionId,
                                         String trackerId)
                                  throws RemoteException

      Returns a data object for a given tracker
      Parameters:
        `sessionId` - User session id.
        `trackerId` - Tracker id.
      Returns:
        Detailed data on the tracker.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`
      Since:
        8.0

    - #### setTrackerData

          void setTrackerData(String sessionId,
                              TrackerSoapDO trackerData)
                       throws RemoteException

      Deprecated. use setTracker3Data instead, which includes tracker unit and autosum foreign children support
      Sets data on a specific tracker, using this method and not setTracker2Data will reset the tracker unit to the default
      Parameters:
        `sessionId` - User session id.
        `trackerData` - Detailed data on the tracker to set.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid or field or icon could not be found.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - when invalid data is specified.
        `com.collabnet.ce.soap60.fault.VersionMismatchFault` - when the object version mismatches the application server.
        `RemoteException`
      Since:
        4.2

    - #### setTracker2Data

          void setTracker2Data(String sessionId,
                               Tracker2SoapDO trackerData)
                        throws RemoteException

      Deprecated. use setTracker3Data instead, which includes autosum foreign children support
      Sets data on a specific tracker
      Parameters:
        `sessionId` - User session id.
        `trackerData` - Detailed data on the tracker to set.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid or field or icon could not be found.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - when invalid data is specified.
        `com.collabnet.ce.soap60.fault.VersionMismatchFault` - when the object version mismatches the application server.
        `RemoteException`
      Since:
        6.2

    - #### setTracker3Data

          void setTracker3Data(String sessionId,
                               Tracker3SoapDO trackerData)
                        throws RemoteException

      Sets data on a specific tracker with autosum foreign children support
      Parameters:
        `sessionId` - User session id.
        `trackerData` - Detailed data on the tracker to set.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid or field or icon could not be found.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - when invalid data is specified.
        `com.collabnet.ce.soap60.fault.VersionMismatchFault` - when the object version mismatches the application server.
        `RemoteException`
      Since:
        8.0

    - #### createTracker

          TrackerSoapDO createTracker(String sessionId,
                                      String projectId,
                                      String trackerName,
                                      String trackerTitle,
                                      String trackerDescription,
                                      String icon)
                               throws RemoteException

      Deprecated. use createTracker3 instead, which includes tracker unit and autosum foreign children support
      Creates a new tracker with an icon
      Parameters:
        `sessionId` - User session id.
        `projectId` - The id of the project under which to create the new tracker
        `trackerName` - The name of the new tracker
        `trackerTitle` - The title of the new tracker
        `trackerDescription` - The description of the new tracker
        `icon` - The tracker icon (null or something between "icon_01.png" and "icon_99.png")
      Returns:
        the tracker soap object
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid or icon could not be found.
        `com.collabnet.ce.soap60.fault.ObjectAlreadyExistsFault` - if an existing tracker already exists
        `RemoteException`
      Since:
        4.3-HOTFIX1

    - #### createTracker2

          Tracker2SoapDO createTracker2(String sessionId,
                                        String projectId,
                                        String trackerName,
                                        String trackerTitle,
                                        String trackerDescription,
                                        String icon,
                                        String trackerUnitId)
                                 throws RemoteException

      Deprecated. use createTracker3 instead, which includes foreign children support
      Creates a new tracker with an icon
      Parameters:
        `sessionId` - User session id.
        `projectId` - The id of the project under which to create the new tracker
        `trackerName` - The name of the new tracker
        `trackerTitle` - The title of the new tracker
        `trackerDescription` - The description of the new tracker
        `icon` - The tracker icon (null or something between "icon_01.png" and "icon_99.png")
        `trackerUnitId` - The tracker unit
      Returns:
        the tracker soap object
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid or icon could not be found.
        `com.collabnet.ce.soap60.fault.ObjectAlreadyExistsFault` - if an existing tracker already exists
        `RemoteException`
      Since:
        6.2

    - #### createTracker3

          Tracker3SoapDO createTracker3(String sessionId,
                                        String projectId,
                                        String trackerName,
                                        String trackerTitle,
                                        String trackerDescription,
                                        String icon,
                                        String trackerUnitId,
                                        boolean autosumForeignChildren)
                                 throws RemoteException

      Creates a new tracker with autosum foreign children support
      Parameters:
        `sessionId` - User session id.
        `projectId` - The id of the project under which to create the new tracker
        `trackerName` - The name of the new tracker
        `trackerTitle` - The title of the new tracker
        `trackerDescription` - The description of the new tracker
        `icon` - The tracker icon (null or something between "icon_01.png" and "icon_99.png")
        `trackerUnitId` - The tracker unit
        `autosumForeignChildren` - The flag indicating whether the autosum calculation of effort and points includes children from foreign projects
      Returns:
        the tracker soap object
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid or icon could not be found.
        `com.collabnet.ce.soap60.fault.ObjectAlreadyExistsFault` - if an existing tracker already exists
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - if the arguments are incorrectly specified
        `RemoteException`
      Since:
        8.0

    - #### setField

          void setField(String sessionId,
                        String objectId,
                        TrackerFieldSoapDO fieldData)
                 throws RemoteException

      Deprecated. use setField2 instead
      Sets a custom/flex-field that is associated with a specific folder (e.g. tracker). This method was introduced to be able to set properties of the help text in TeamForge 5.4.1
      Parameters:
        `sessionId` - User session id.
        `objectId` - Object (e.g. tracker) for which to set the field information.
        `fieldData` - the custom/flex-field to associate with a specific folder
      Throws:
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id or fieldData is invalid
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.VersionMismatchFault` - if the object has been updated since this fieldDO was fetched
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - if the arguments are incorrectly specified. See FaultSummary for detail for the following: - DUPLICATE_FIELD_VALUE - ILLEGAL_FIELD_VALUE - INVALID_FIELD_VALUE - INVALID_DEFAULT_VALUE - INVALID_FIELD_OPTIONS_REQUIRED_DISABLED - INVALID_FIELD_VALUE_LENGTH - REQUIRED_FIELD_MISSING - INVALID_FIELD_PATTERN
        `com.collabnet.ce.soap60.fault.InvalidOperationFault` - if the operation is not allowed. See FaultSummary for detail for the following: - INVALID_OPTION_DISABLE_RESERVED_FIELD - INVALID_OPTION_DISABLE_IN_USE_FIELD
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `com.collabnet.ce.soap60.fault.DependencyViolationFault` - if changing a status violates artifact dependency
        `RemoteException`
      Since:
        4.3-HOTFIX1
      See Also:
        `FaultSummary`

    - #### setField2

          void setField2(String sessionId,
                         String objectId,
                         TrackerField2SoapDO fieldData)
                  throws RemoteException

      Sets a custom/flex-field that is associated with a specific folder (e.g. tracker). This method was introduced to be able to set properties of the tracker field and also supporting to set the field role filters for the 'assignedTo' field
      Parameters:
        `sessionId` - User session id.
        `objectId` - Object (e.g. tracker) for which to set the field information.
        `fieldData` - the custom/flex-field to associate with a specific folder
      Throws:
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id or fieldData is invalid
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.VersionMismatchFault` - if the object has been updated since this fieldDO was fetched
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - if the arguments are incorrectly specified. See FaultSummary for detail for the following: - DUPLICATE_FIELD_VALUE - ILLEGAL_FIELD_VALUE - INVALID_FIELD_VALUE - INVALID_DEFAULT_VALUE - INVALID_FIELD_OPTIONS_REQUIRED_DISABLED - INVALID_FIELD_VALUE_LENGTH - REQUIRED_FIELD_MISSING - INVALID_FIELD_PATTERN
        `com.collabnet.ce.soap60.fault.InvalidOperationFault` - if the operation is not allowed. See FaultSummary for detail for the following: - INVALID_OPTION_DISABLE_RESERVED_FIELD - INVALID_OPTION_DISABLE_IN_USE_FIELD
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `com.collabnet.ce.soap60.fault.DependencyViolationFault` - if changing a status violates artifact dependency
        `RemoteException`
      Since:
        16.7
      See Also:
        `FaultSummary`

    - #### addTextField

          void addTextField(String sessionId,
                            String trackerId,
                            String fieldName,
                            int displayColumns,
                            int displayLines,
                            boolean isRequired,
                            boolean isDisabled,
                            boolean isHiddenOnCreate,
                            String defaultValue,
                            String helpText,
                            String pattern)
                     throws RemoteException

      Adds a custom text field to a tracker.
      Parameters:
        `sessionId` - User session id.
        `trackerId` - The tracker to add the field to.
        `fieldName` - the name of the field
        `displayColumns` - the width of the display area
        `displayLines` - the height of the display area
        `isRequired` - if the field is required
        `isDisabled` - if the field is disabled
        `isHiddenOnCreate` - if the field is hidden when first created
        `defaultValue` - default value
        `helpText` - The help text for the field
        `pattern` - The field validation pattern
      Throws:
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id or fieldData is invalid
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.VersionMismatchFault` - if the object has been updated since this fieldDO was fetched
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - if the arguments are incorrectly specified
        `com.collabnet.ce.soap60.fault.InvalidOperationFault` - if the operation is not allowed
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`
      Since:
        4.3-HOTFIX1

    - #### addSingleSelectChildField

          void addSingleSelectChildField(String sessionId,
                                         String trackerId,
                                         String fieldName,
                                         String[] fieldValues,
                                         String parentFieldId,
                                         com.collabnet.ce.soap60.types.SoapNamedValues parentChildFieldValueMap,
                                         String helpText)
                                  throws RemoteException

      Adds a custom single select field to a tracker.
      Parameters:
        `sessionId` - User session id.
        `trackerId` - The tracker to add the field to.
        `fieldName` - the name of the field
        `fieldValues` - Array of valid field values
        `parentFieldId` - The id of the parent field
        `parentChildFieldValueMap` - soapNamedValues which keeps mapping between parent field values and child values
        `helpText` - the help text for the field
      Throws:
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id or fieldData is invalid
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.VersionMismatchFault` - if the object has been updated since this fieldDO was fetched
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - if the arguments are incorrectly specified
        `com.collabnet.ce.soap60.fault.InvalidOperationFault` - if the operation is not allowed
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`
      Since:
        5.4.1

    - #### addSingleSelectField

          void addSingleSelectField(String sessionId,
                                    String trackerId,
                                    String fieldName,
                                    boolean isRequired,
                                    boolean isDisabled,
                                    boolean isHiddenOnCreate,
                                    String[] fieldValues,
                                    String defaultValue,
                                    String helpText)
                             throws RemoteException

      Adds a custom single select field to a tracker.
      Parameters:
        `sessionId` - User session id.
        `trackerId` - The tracker to add the field to.
        `fieldName` - the name of the field
        `isRequired` - if the field is required
        `isDisabled` - if the field is disabled
        `isHiddenOnCreate` - if the field is hidden when first created
        `fieldValues` - Array of valid field values
        `defaultValue` - default value
        `helpText` - the help text for the field
      Throws:
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id or fieldData is invalid
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.VersionMismatchFault` - if the object has been updated since this fieldDO was fetched
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - if the arguments are incorrectly specified
        `com.collabnet.ce.soap60.fault.InvalidOperationFault` - if the operation is not allowed
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`
      Since:
        4.3-HOTFIX1

    - #### addMultiSelectField

          void addMultiSelectField(String sessionId,
                                   String trackerId,
                                   String fieldName,
                                   int displayLines,
                                   boolean isRequired,
                                   boolean isDisabled,
                                   boolean isHiddenOnCreate,
                                   String[] fieldValues,
                                   String[] defaultValues,
                                   String helpText)
                            throws RemoteException

      Adds a custom multi select field to a tracker.
      Parameters:
        `sessionId` - User session id.
        `trackerId` - The tracker to add the field to.
        `fieldName` - the name of the field
        `displayLines` - the height of the display area
        `isRequired` - if the field is required
        `isDisabled` - if the field is disabled
        `isHiddenOnCreate` - if the field is hidden when first created
        `fieldValues` - possible values
        `defaultValues` - default values
        `helpText` - the help text for the field
      Throws:
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id or fieldData is invalid
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.VersionMismatchFault` - if the object has been updated since this fieldDO was fetched
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - if the arguments are incorrectly specified
        `com.collabnet.ce.soap60.fault.InvalidOperationFault` - if the operation is not allowed
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`
      Since:
        4.3-HOTFIX1

    - #### addUserSelectField

          void addUserSelectField(String sessionId,
                                  String trackerId,
                                  String fieldName,
                                  int displayLines,
                                  boolean isRequired,
                                  boolean isDisabled,
                                  boolean isHiddenOnCreate,
                                  String[] defaultValues,
                                  String userFilter,
                                  String helpText)
                           throws RemoteException

      Adds a custom User selection field to a tracker.
      Parameters:
        `sessionId` - User session id.
        `trackerId` - The tracker to add the field to.
        `fieldName` - the name of the field
        `displayLines` - the height of the display area
        `isRequired` - if the field is required
        `isDisabled` - if the field is disabled
        `isHiddenOnCreate` - if the field is hidden when first created
        `defaultValues` - default values for this field. Must be valid usernames
        `userFilter` - is the filter
        `helpText` - The help text of the field
      Throws:
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id or fieldData is invalid
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.VersionMismatchFault` - if the object has been updated since this fieldDO was fetched
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - if the arguments are incorrectly specified
        `com.collabnet.ce.soap60.fault.InvalidOperationFault` - if the operation is not allowed
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`
      Since:
        4.3-SP1
      See Also:
        `TrackerFieldSoapDO.FIELD_USER_FILTER_PROJECT_MEMBER`, `TrackerFieldSoapDO.FIELD_USER_FILTER_ALL`

    - #### addDateField

          void addDateField(String sessionId,
                            String trackerId,
                            String fieldName,
                            boolean isRequired,
                            boolean isDisabled,
                            boolean isHiddenOnCreate,
                            String helpText)
                     throws RemoteException

      Adds a custom Date field to a tracker.
      Parameters:
        `sessionId` - User session id.
        `trackerId` - The tracker to add the field to.
        `fieldName` - the name of the field
        `isRequired` - if the field is required
        `isDisabled` - if the field is disabled
        `isHiddenOnCreate` - if the field is hidden when first created
        `helpText` - the help text of the field
      Throws:
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id or fieldData is invalid
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.VersionMismatchFault` - if the object has been updated since this fieldDO was fetched
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - if the arguments are incorrectly specified
        `com.collabnet.ce.soap60.fault.InvalidOperationFault` - if the operation is not allowed
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`
      Since:
        4.3-SP1

    - #### deleteField

          void deleteField(String sessionId,
                           String objectId,
                           String fieldId)
                    throws RemoteException

      Deletes a custom/flex-field .
      Parameters:
        `sessionId` - User session id.
        `objectId` - Object (e.g. tracker).
        `fieldId` - the id of the field to delete
      Throws:
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id or fieldData is invalid
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.InvalidOperationFault` - if the operation is not allowed.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`
      Since:
        4.3-HOTFIX1

    - #### getFields

          TrackerFieldSoapDO[] getFields(String sessionId,
                                         String trackerId)
                                  throws RemoteException

      Deprecated. use getFields2 instead
      Returns the custom/flex-fields associated with a specific tracker. This method has been introduced to also return the properties of the planning folder, the actual, estimated and remaining effort fields as well as the autosumming flag.
      Parameters:
        `sessionId` - User session id.
        `trackerId` - The tracker for which to return field information.
      Returns:
        Array of all field values.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`
      Since:
        4.3-HOTFIX1

    - #### getFields2

          TrackerField2SoapDO[] getFields2(String sessionId,
                                           String trackerId)
                                    throws RemoteException

      Returns the custom/flex-fields associated with a specific tracker. In addition to the features of getFields api, it returns the field role filters of the field(eg: 'assignedTo' field) in the Tracker
      Parameters:
        `sessionId` - User session id.
        `trackerId` - The tracker for which to return field information.
      Returns:
        Array of all field values.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`
      Since:
        16.7

    - #### addSeparator

          void addSeparator(String sessionId,
                            String trackerId,
                            String separatorType,
                            String separatorLabel)
                     throws RemoteException

      Adds a separator to a tracker. The separator will be added at the end of tracker fields. To reorder separator and fields, use getOrderedTrackerFields and reorderTrackerFields.
      Parameters:
        `sessionId` - User session id.
        `trackerId` - The tracker to add the separator to.
        `separatorType` - the type of the separator, either OrderedTrackerFieldSoapRow.ROW_SEPARATOR OrderedTrackerFieldSoapRow.COLUMN_SEPARATOR or OrderedTrackerFieldSoapRow .SECTION_SEPARATOR.
        `separatorLabel` - the label of the separator
      Throws:
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - if the arguments are incorrectly specified
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `com.collabnet.ce.soap60.fault.ObjectAlreadyExistsFault` - if a separator with the same id exists
        `RemoteException`
      Since:
        5.4.1

    - #### deleteSeparator

          void deleteSeparator(String sessionId,
                               String trackerId,
                               String layoutId)
                        throws RemoteException

      Deletes a separator of a tracker layout.
      Parameters:
        `sessionId` - User session id.
        `trackerId` - The tracker to delete the separator from.
        `layoutId` - the layout id of the separator. To get the layout id, use getOrderedTrackerFields.
      Throws:
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - if the arguments are incorrectly specified
        `com.collabnet.ce.soap60.fault.InvalidOperationFault` - if the operation is not allowed
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`
      Since:
        5.4.1

    - #### getOrderedTrackerFields

          OrderedTrackerFieldSoapList getOrderedTrackerFields(String sessionId,
                                                              String trackerId)
                                                       throws RemoteException

      Returns all fields and separators in the given tracker with layout information.
      Parameters:
        `sessionId` - User session id.
        `trackerId` - The tracker for which to return field information.
      Returns:
        Array of all fields and separators.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`
      Since:
        5.4.1

    - #### reorderTrackerFields

          void reorderTrackerFields(String sessionId,
                                    String trackerId,
                                    String[] layoutIds)
                             throws RemoteException

      Sets a new order of the fields and the separators within a tracker. The fields and separators will be listed in this new order in UI and in the methods that list the fields and separators in the SOAP calls.
      Parameters:
        `sessionId` - User session id.
        `trackerId` - Id of tracker which all the fields and the separators belong to.
        `layoutIds` - An array of layout ids which can be obtained by getOrderedTrackerFields(). Layout id is different from field id and some system fields and separators do not have field id but only layout id.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - When the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - When any of the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - If invalid argument value is passed.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - When the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.SystemFault` - When an unexpected system level error occurs.
        `RemoteException`
      Since:
        5.4.1

    - #### getArtifactList

          ArtifactSoapList getArtifactList(String sessionId,
                                           String containerId,
                                           com.collabnet.ce.soap60.types.SoapFilter[] filters)
                                    throws RemoteException

      Deprecated. in fovor of getArtifactList2
      Returns a filtered list of artifacts within the specified container (project or tracker). See ArtifactSoapDO for filter constant values: ArtifactSoapDO.FILTER_ASSIGNED_TO, etc.
      Change History
      Version 4.2
      - Added additional parameter (`filters`) for filtering artifact lists.
      Version 4.4
      - Added a limit to the number of rows that could be retrieved. This limit is by default 5000 but is configurable
      - it is substantially obsolete by enhancements to getArtifactDetailList(), which now includes the ability to select which columns are returned, as well as the ability to fetch subsets of data on a "paged" basis, and to return sorted results.
      Parameters:
        `sessionId` - User session id.
        `containerId` - ID of a project or a tracker.
        `filters` - Array of filters to apply (null to return unfiltered list).
      Returns:
        List of filtered artifacts.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.InvalidFilterFault` - when the specified filters are invalid.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`
      Since:
        4.1

    - #### getArtifactList2

          Artifact2SoapList getArtifactList2(String sessionId,
                                             String containerId,
                                             com.collabnet.ce.soap60.types.SoapFilter[] filters)
                                      throws RemoteException

      Returns a filtered list of artifacts within the specified container (project or tracker). See ArtifactSoapDO for filter constant values: ArtifactSoapDO.FILTER_ASSIGNED_TO, etc.
      Parameters:
        `sessionId` - User session id.
        `containerId` - ID of a project or a tracker.
        `filters` - Array of filters to apply (null to return unfiltered list).
      Returns:
        List of filtered artifacts.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.InvalidFilterFault` - when the specified filters are invalid.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`
      Since:
        8.0

    - #### getCrossTrackerArtifactList

          ArtifactDetailSoapList getCrossTrackerArtifactList(String sessionId,
                                                             String containerId,
                                                             com.collabnet.ce.soap60.types.SoapFilter[] filters,
                                                             String[] selectedColumns)
                                                      throws RemoteException

      Deprecated. in favor of getCrossTrackerArtifactList2
      Returns a filtered list of artifacts within the specified container (project or tracker). Since this is a cross tracker query, flex fields may not be populated.
      Parameters:
        `sessionId` - User session id.
        `containerId` - ID of a project or a tracker. (should not be null)
        `filters` - Array of filters to apply (null to return unfiltered list).
        `selectedColumns` - String array of column names to be selected (null to return all columns). See ArtifactSoapDO for column names constant values e.g. ArtifactSoapDO.COLUMN_CATEGORY
      Returns:
        List of filtered artifacts.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.InvalidFilterFault` - when the specified filters are invalid.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`
      Since:
        5.3

    - #### getCrossTrackerArtifactList2

          ArtifactDetail2SoapList getCrossTrackerArtifactList2(String sessionId,
                                                               String containerId,
                                                               com.collabnet.ce.soap60.types.SoapFilter[] filters,
                                                               String[] selectedColumns)
                                                        throws RemoteException

      Returns a filtered list of artifacts within the specified container (project or tracker). Since this is a cross tracker query, flex fields may not be populated.
      Parameters:
        `sessionId` - User session id.
        `containerId` - ID of a project or a tracker. (should not be null)
        `filters` - Array of filters to apply (null to return unfiltered list).
        `selectedColumns` - String array of column names to be selected (null to return all columns). See Artifact2SoapDO for column names constant values e.g. Artifact2SoapDO.COLUMN_CATEGORY.
      Returns:
        List of filtered artifacts.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.InvalidFilterFault` - when the specified filters are invalid.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`
      Since:
        8.0

    - #### getArtifactDetailList

          ArtifactDetailSoapList getArtifactDetailList(String sessionId,
                                                       String trackerId,
                                                       String[] selectedColumns,
                                                       com.collabnet.ce.soap60.types.SoapFilter[] filters,
                                                       com.collabnet.ce.soap60.types.SoapSortKey[] sortKeys,
                                                       int startIndex,
                                                       int maxRows,
                                                       boolean exceptionIfExpiredCache,
                                                       boolean forceNewQuery)
                                                throws RemoteException

      Deprecated. in favor of getArtifactDetailList2
      Returns a filtered and ordered list of artifacts from the specified tracker. It gives the user the ability to ask only for certain results with the parameters startIndex and maxRows. In this way the method can be used to implement paging. A special value of -1 for the maxRows parameter will be interpreted as asking for the complete list. Unlike the corresponding method in earlier versions of the soap interface (soap44, etc.), this method now returns data for all flex fields, whether they have values or not. Flex fields with no values will have NULL values in the values[] array

      This method makes use of server-side caching of the complete list in order to more efficiently return results for requests for subsequent "pages" of data. In normal usage, requesting a subsequent page of a given list will return data from this cache unless the cache has expired, in which case the query will transparently be re-executed before return the results. Note that this transparent re-execution can result in slight inconsistencies in the data, if the underlying data has changed. The exceptionIfExpiredCache and forceNewQuery flags can be used to tune cache behavior.

      Caching is managed transparently by the application server, using the filters and selectedColumns parameters to identify subsequent requests for subsets of the same data set. The cache is associated with the user session. Note that the implementation may choose not to cache results if the entire list is being fetched (via specifying -1 for maxRows).

      Note: You can't sort or filter by a non selected column.

      See ArtifactSoapDO for column and filter names constant values: ArtifactSoapDO.COLUMN_TITLE, ArtifactSoapDO.COLUMN_ASSIGNED_TO, FILTER_PRIORITY, FILTER, FILTER_CATEGORY, etc.

      Parameters:
        `sessionId` - User session id.
        `trackerId` - Tracker id.
        `selectedColumns` - String array of column names to be selected (null to return all columns). See ArtifactSoapDO for column names constant values e.g. ArtifactSoapDO .COLUMN_CATEGORY
        `filters` - Array of filters to apply (null to return unfiltered list). See ArtifactSoapDO for filters names constant values e.g. ArtifactSoapDO .FILTER_PRIORITY. Valid date formats are SoapFilter.DATE_FORMAT and SoapFilter.DATE_ONLY_FORMAT.
        `sortKeys` - Array of `SortKey` to apply (null to return a default order list that is by ID). See ArtifactSoapDO for column names constant values e.g. ArtifactSoapDO .COLUMN_PRIORITY
        `startIndex` - The index from which to return the results.
        `maxRows` - The max quantity of elements to be returned (-1 will return the full list).
        `exceptionIfExpiredCache` - Causes the method to throw an exception if it doesn't have the results in the cache, rather than the default behavior of silently re-executing the query. This can be used if the caller is fetching paged data and wants to be assured that the pages are from one consistent snapshot of the data.
        `forceNewQuery` - force the re-execution of the query, ignoring any cached copy of the search result.
      Returns:
        List of filtered artifacts.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.InvalidFilterFault` - when the specified filters are invalid.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`
      Since:
        4.3-HOTFIX1

    - #### getArtifactDetailList2

          ArtifactDetail2SoapList getArtifactDetailList2(String sessionId,
                                                         String trackerId,
                                                         String[] selectedColumns,
                                                         com.collabnet.ce.soap60.types.SoapFilter[] filters,
                                                         com.collabnet.ce.soap60.types.SoapSortKey[] sortKeys,
                                                         int startIndex,
                                                         int maxRows,
                                                         boolean exceptionIfExpiredCache,
                                                         boolean forceNewQuery)
                                                  throws RemoteException

      Returns a filtered and ordered list of artifacts from the specified tracker. It gives the user the ability to ask only for certain results with the parameters startIndex and maxRows. In this way the method can be used to implement paging. A special value of -1 for the maxRows parameter will be interpreted as asking for the complete list. Unlike the corresponding method in earlier versions of the soap interface (soap44, etc.), this method now returns data for all flex fields, whether they have values or not. Flex fields with no values will have NULL values in the values[] array

      This method makes use of server-side caching of the complete list in order to more efficiently return results for requests for subsequent "pages" of data. In normal usage, requesting a subsequent page of a given list will return data from this cache unless the cache has expired, in which case the query will transparently be re-executed before return the results. Note that this transparent re-execution can result in slight inconsistencies in the data, if the underlying data has changed. The exceptionIfExpiredCache and forceNewQuery flags can be used to tune cache behavior.

      Caching is managed transparently by the application server, using the filters and selectedColumns parameters to identify subsequent requests for subsets of the same data set. The cache is associated with the user session. Note that the implementation may choose not to cache results if the entire list is being fetched (via specifying -1 for maxRows).

      Note: You can't sort or filter by a non selected column.

      See ArtifactSoapDO for column and filter names constant values: ArtifactSoapDO.COLUM ArtifactSoapDO.COLUMN_ASSIGNED_TO, FILTER_PRIORITY, FILTER, FILTER_CATEGORY, etc.

      Parameters:
        `sessionId` - User session id.
        `trackerId` - Tracker id.

        See ArtifactSoapDO for filters names constant values e.g. ArtifactSoapDO .FILTER_PRIORITY. Valid date formats are SoapFilter.DATE_FORMAT and SoapFilter.DATE_ONLY_FORMAT.

        `sortKeys` - Array of `SortKey` to apply (null to return a default order list that is by ID). See ArtifactSoapDO for column names constant values e.g. Artifact2SoapDO .COLUMN_AUTO_SUMMING_POINTS
        `startIndex` - The index from which to return the results.
        `maxRows` - The max quantity of elements to be returned (-1 will return the full list).
        `exceptionIfExpiredCache` - Causes the method to throw an exception if it doesn't have the results in the cache, rather than the default behavior of silently re-executing the query. This can be used if the caller is fetching paged data and wants to be assured that the pages are from one consistent snapshot of the data.
        `forceNewQuery` - force the re-execution of the query, ignoring any cached copy of the search result.
      Returns:
        List of filtered artifacts.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.InvalidFilterFault` - when the specified filters are invalid.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`
      Since:
        8.0

    - #### findArtifacts

          ArtifactSoapList findArtifacts(String sessionId,
                                         String queryString,
                                         String projectId,
                                         boolean searchAttachments)
                                  throws RemoteException

      Deprecated. in favor of findArtifacts2
      Finds a list of artifacts matching a search string.
      Parameters:
        `sessionId` - User session id.
        `queryString` - Query string.
        `projectId` - The project in which to find artifacts. (if null, search all projects)
        `searchAttachments` - Whether to search attachments.
      Returns:
        List of artifacts matching search criteria.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified project id is invalid.
        `com.collabnet.ce.soap60.fault.SearchQuerySyntaxFault` - when the specified search query string is syntactically invalid.
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - when the specified query string is invalid.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system level error occurs.
        `RemoteException`
      Since:
        4.1

    - #### findArtifacts2

          Artifact2SoapList findArtifacts2(String sessionId,
                                           String queryString,
                                           String projectId,
                                           boolean searchAttachments)
                                    throws RemoteException

      Finds a list of artifacts matching a search string.
      Parameters:
        `sessionId` - User session id.
        `queryString` - Query string.
        `projectId` - The project in which to find artifacts. (if null, search all projects)
        `searchAttachments` - Whether to search attachments.
      Returns:
        List of artifacts matching search criteria.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified project id is invalid.
        `com.collabnet.ce.soap60.fault.SearchQuerySyntaxFault` - when the specified search query string is syntactically invalid.
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - when the specified query string is invalid.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system level error occurs.
        `RemoteException`
      Since:
        8.0

    - #### getArtifactData

          ArtifactSoapDO getArtifactData(String sessionId,
                                         String artifactId)
                                  throws RemoteException

      Deprecated. in favor of getArtifactData3
      Returns data associated with the specified artifact. Unlike the corresponding method in earlier versions of the soap interface (soap44, etc.), this method now returns data for all flex fields, whether they have values or not. Flex fields with no values will have NULL values in the values[] array
      Parameters:
        `sessionId` - User session id.
        `artifactId` - Artifact id.
      Returns:
        the data associated with the artifact at the given path
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`
      Since:
        4.1

    - #### getArtifactData2

          Artifact2SoapDO getArtifactData2(String sessionId,
                                           String artifactId)
                                    throws RemoteException

      Deprecated. in favor of getArtifactData3
      Returns data associated with the specified artifact. Unlike the corresponding method in earlier versions of the soap interface (soap44, etc.), this method now returns data for all flex fields, whether they have values or not. Flex fields with no values will have NULL values in the values[] array
      Parameters:
        `sessionId` - User session id.
        `artifactId` - Artifact id.
      Returns:
        the data associated with the artifact at the given path
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`
      Since:
        8.0

    - #### getArtifactData3

          Artifact3SoapDO getArtifactData3(String sessionId,
                                           String artifactId)
                                    throws RemoteException

      Returns data associated with the specified artifact. Unlike the corresponding method in earlier versions of the soap interface (soap44, etc.), this method now returns data for all flex fields, whether they have values or not. Flex fields with no values will have NULL values in the values[] array
      Parameters:
        `sessionId` - User session id.
        `artifactId` - Artifact id.
      Returns:
        the data associated with the artifact at the given path
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`
      Since:
        17.4

    - #### setArtifactData

          void setArtifactData(String sessionId,
                               ArtifactSoapDO artifactData,
                               String comment,
                               String attachmentFileName,
                               String attachmentMimeType,
                               String attachmentFileId)
                        throws RemoteException

      Deprecated. in favor of setArtifactData4
      Sets data associated with the specified artifact.
      Parameters:
        `sessionId` - User session id.
        `artifactData` - the data associated with the artifact at the given path
        `comment` - Comment associated with the change.
        `attachmentFileName` - Name of the attached file (or null)
        `attachmentMimeType` - Mime type of the attached file (or null)
        `attachmentFileId` - ID of the attached file (previously uploaded via *FileStorage service) or null
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.VersionMismatchFault` - when the object data is stale.
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - when the artifact data is invalid.
        `com.collabnet.ce.soap60.fault.InconsistentFieldValueFault` - when field hierarchy has been changed and the values are no longer valid.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `com.collabnet.ce.soap60.fault.WorkflowViolationFault` - when workflow rule is violated
        `com.collabnet.ce.soap60.fault.DependencyViolationFault` - when dependency rule is violated
        `com.collabnet.ce.soap60.fault.PlanningFolderRuleViolationFault` - when planning folder rule is violated
        `RemoteException`
      Since:
        4.1

    - #### setArtifactData2

          void setArtifactData2(String sessionId,
                                ArtifactSoapDO artifactData,
                                String comment,
                                AttachmentSoapDO[] attachments)
                         throws RemoteException

      Deprecated. in favor of setArtifactData4
      Sets data associated along with multiple attachments with the specified artifact.
      Parameters:
        `sessionId` - User session id.
        `artifactData` - the data associated with the artifact at the given path
        `comment` - Comment associated with the change.
        `attachments` - attached file List
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.VersionMismatchFault` - when the object data is stale.
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - when the artifact data is invalid.
        `com.collabnet.ce.soap60.fault.InconsistentFieldValueFault` - when field hierarchy has been changed and the values are no longer valid.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `com.collabnet.ce.soap60.fault.WorkflowViolationFault` - when workflow rule is violated
        `com.collabnet.ce.soap60.fault.DependencyViolationFault` - when dependency rule is violated
        `com.collabnet.ce.soap60.fault.PlanningFolderRuleViolationFault` - when planning folder rule is violated
        `RemoteException`
      Since:
        6.2

    - #### setArtifactData3

          void setArtifactData3(String sessionId,
                                Artifact2SoapDO artifactData,
                                String comment,
                                AttachmentSoapDO[] attachments)
                         throws RemoteException

      Deprecated. in favor of setArtifactData4
      Sets data associated along with multiple attachments with the specified artifact.
      Parameters:
        `sessionId` - User session id.
        `artifactData` - the data associated with the artifact at the given path
        `comment` - Comment associated with the change.
        `attachments` - attached file List
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.VersionMismatchFault` - when the object data is stale.
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - when the artifact data is invalid.
        `com.collabnet.ce.soap60.fault.InconsistentFieldValueFault` - when field hierarchy has been changed and the values are no longer valid.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `com.collabnet.ce.soap60.fault.WorkflowViolationFault` - when workflow rule is violated
        `com.collabnet.ce.soap60.fault.DependencyViolationFault` - when dependency rule is violated
        `com.collabnet.ce.soap60.fault.PlanningFolderRuleViolationFault` - when planning folder rule is violated
        `RemoteException`
      Since:
        8.0

    - #### setArtifactData4

          void setArtifactData4(String sessionId,
                                Artifact3SoapDO artifactData,
                                String comment,
                                AttachmentSoapDO[] attachments)
                         throws RemoteException

      Sets data associated along with multiple attachments with the specified artifact.
      Parameters:
        `sessionId` - User session id.
        `artifactData` - the data associated with the artifact at the given path
        `comment` - Comment associated with the change.
        `attachments` - attached file List
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.VersionMismatchFault` - when the object data is stale.
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - when the artifact data is invalid.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `com.collabnet.ce.soap60.fault.WorkflowViolationFault` - when workflow rule is violated
        `com.collabnet.ce.soap60.fault.DependencyViolationFault` - when dependency rule is violated
        `com.collabnet.ce.soap60.fault.PlanningFolderRuleViolationFault` - when planning folder rule is violated
        `com.collabnet.ce.soap60.fault.InconsistentFieldValueFault` - when field hierarchy has been changed and the values are no longer valid
        `RemoteException`
      Since:
        17.4

    - #### createArtifact

          ArtifactSoapDO createArtifact(String sessionId,
                                        String trackerId,
                                        String title,
                                        String description,
                                        String group,
                                        String category,
                                        String status,
                                        String customer,
                                        int priority,
                                        int estimatedEffort,
                                        int remainingEffort,
                                        boolean autosumming,
                                        int points,
                                        String assignedUsername,
                                        String releaseId,
                                        String planningFolderId,
                                        com.collabnet.ce.soap60.types.SoapFieldValues flexFields,
                                        String attachmentFileName,
                                        String attachmentMimeType,
                                        String attachmentFileId)
                                 throws RemoteException

      Deprecated. in favor of createArtifact4
      Creates a new artifact.
      Parameters:
        `sessionId` - User session id.
        `trackerId` - Tracker id.
        `title` - Artifact title.
        `description` - Artifact description.
        `group` - Artifact group.
        `category` - Artifact category.
        `status` - Artifact status.
        `customer` - Customer.
        `priority` - Artifact priority.
        `estimatedEffort` - Estimated effort to close artifact.
        `remainingEffort` - Remaining effort to close artifact.
        `autosumming` - Determines whether autosumming should be enabled for the newly created artifact.
        `points` - The story points for this artifact.
        `assignedUsername` - User this artifact should be assigned to.
        `releaseId` - Release this artifact is assigned with.
        `planningFolderId` - planning folder, this artifact belongs to
        `flexFields` - Flex field values.
        `attachmentFileName` - Name of the attached file (or null)
        `attachmentMimeType` - Mime type of the attached file (or null)
        `attachmentFileId` - ID of the attached file (previously uploaded via *FileStorage service) or null
      Returns:
        Newly created artifact object.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - when the artifact data is invalid.
        `com.collabnet.ce.soap60.fault.InconsistentFieldValueFault` - when field hierarchy has been changed and the values are no longer valid
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`
      Since:
        4.2

    - #### createArtifact2

          ArtifactSoapDO createArtifact2(String sessionId,
                                         String trackerId,
                                         String title,
                                         String description,
                                         String group,
                                         String category,
                                         String status,
                                         String customer,
                                         int priority,
                                         int estimatedEffort,
                                         int remainingEffort,
                                         boolean autosumming,
                                         int points,
                                         String assignedUsername,
                                         String releaseId,
                                         String planningFolderId,
                                         com.collabnet.ce.soap60.types.SoapFieldValues flexFields,
                                         AttachmentSoapDO[] attachments)
                                  throws RemoteException

      Deprecated. in favor of createArtifact4
      Creates a new artifact with multiple attachments.
      Parameters:
        `sessionId` - User session id.
        `trackerId` - Tracker id.
        `title` - Artifact title.
        `description` - Artifact description.
        `group` - Artifact group.
        `category` - Artifact category.
        `status` - Artifact status.
        `customer` - Customer.
        `priority` - Artifact priority.
        `estimatedEffort` - Estimated effort to close artifact.
        `remainingEffort` - Remaining effort to close artifact.
        `autosumming` - Determines whether autosumming should be enabled for the newly created artifact.
        `points` - The story points for this artifact.
        `assignedUsername` - User this artifact should be assigned to.
        `releaseId` - Release this artifact is assigned with.
        `planningFolderId` - planning folder, this artifact belongs to
        `flexFields` - Flex field values.
        `attachments` - attached file List (or null)
      Returns:
        Newly created artifact object.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - when the artifact data is invalid.
        `com.collabnet.ce.soap60.fault.InconsistentFieldValueFault` - when field hierarchy has been changed and the values are no longer valid
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`
      Since:
        6.2

    - #### createArtifact3

          Artifact2SoapDO createArtifact3(String sessionId,
                                          String trackerId,
                                          String title,
                                          String description,
                                          String group,
                                          String category,
                                          String status,
                                          String customer,
                                          int priority,
                                          int estimatedEffort,
                                          int remainingEffort,
                                          boolean autosumming,
                                          int points,
                                          boolean autoSummingPoints,
                                          String assignedUsername,
                                          String releaseId,
                                          String planningFolderId,
                                          String teamId,
                                          com.collabnet.ce.soap60.types.SoapFieldValues flexFields,
                                          AttachmentSoapDO[] attachments)
                                   throws RemoteException

      Deprecated. in favor of createArtifact4
      Creates a new artifact with multiple attachments and flag to enable the autosumming_points.
      Parameters:
        `sessionId` - User session id.
        `trackerId` - Tracker id.
        `title` - Artifact title.
        `description` - Artifact description.
        `group` - Artifact group.
        `category` - Artifact category.
        `status` - Artifact status.
        `customer` - Customer.
        `priority` - Artifact priority.
        `estimatedEffort` - Estimated effort to close artifact. This will be ignored if autosumming is set to true.
        `remainingEffort` - Remaining effort to close artifact. This will be ignored if autosumming is set to true.
        `autosumming` - Determines whether autosumming should be enabled for the newly created artifact.
        `points` - The story points for this artifact. This will be ignored if autoSummingPoints is set to true.
        `autoSummingPoints` - Determines whether autoSummingPoints should be enabled for the newly created artifact.
        `assignedUsername` - User this artifact should be assigned to.
        `releaseId` - Release this artifact is assigned with.
        `planningFolderId` - planning folder, this artifact belongs to
        `teamId` - team, this artifact belongs to
        `flexFields` - Flex field values.
        `attachments` - attached file List (or null)
      Returns:
        Newly created artifact object.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - when the artifact data is invalid.
        `com.collabnet.ce.soap60.fault.InconsistentFieldValueFault` - when field hierarchy has been changed and the values are no longer valid
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `RemoteException`
      Since:
        8.0

    - #### createArtifact4

          Artifact3SoapDO createArtifact4(String sessionId,
                                          String trackerId,
                                          String title,
                                          String description,
                                          String group,
                                          String category,
                                          String status,
                                          String customer,
                                          int priority,
                                          int estimatedEffort,
                                          int remainingEffort,
                                          boolean autosumming,
                                          int points,
                                          boolean autoSummingPoints,
                                          String assignedUsername,
                                          String releaseId,
                                          String planningFolderId,
                                          String teamId,
                                          com.collabnet.ce.soap60.types.SoapFieldValues flexFields,
                                          AttachmentSoapDO[] attachments,
                                          String[] tagNames)
                                   throws RemoteException

      Creates a new artifact with multiple attachments, flag to enable the autosumming_points and tags.
      Parameters:
        `sessionId` - User session id.
        `trackerId` - Tracker id.
        `title` - Artifact title.
        `description` - Artifact description.
        `group` - Artifact group.
        `category` - Artifact category.
        `status` - Artifact status.
        `customer` - Customer.
        `priority` - Artifact priority.
        `estimatedEffort` - Estimated effort to close artifact. This will be ignored if autosumming is set to true.
        `remainingEffort` - Remaining effort to close artifact. This will be ignored if autosumming is set to true.
        `autosumming` - Determines whether autosumming should be enabled for the newly created artifact.
        `points` - The story points for this artifact. This will be ignored if autoSummingPoints is set to true.
        `autoSummingPoints` - Determines whether autoSummingPoints should be enabled for the newly created artifact.
        `assignedUsername` - User this artifact should be assigned to.
        `releaseId` - Release this artifact is assigned with.
        `planningFolderId` - planning folder, this artifact belongs to
        `teamId` - team, this artifact belongs to
        `flexFields` - Flex field values.
        `attachments` - attached file List (or null)
        `tagNames` - tag names
        Note:. Tags will be created, if they do not exist in the project.
        Use TagAppSoap#listTags(java.lang.String, java.lang.String) to get the tags existing in a project.
      Returns:
        Newly created artifact object.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - when the artifact data is invalid.
        `com.collabnet.ce.soap60.fault.InconsistentFieldValueFault` - when field hierarchy has been changed and the values are no longer valid
        `RemoteException`
      Since:
        17.4

    - #### moveArtifact

          ArtifactSoapDO moveArtifact(String sessionId,
                                      String artifactId,
                                      String targetFolderId,
                                      String newAssignee)
                               throws RemoteException

      Deprecated. in favor of moveArtifact2
      Moves an artifact to a specified target folder.
      Parameters:
        `sessionId` - User session id.
        `artifactId` - ID of artifact to move.
        `targetFolderId` - Target folder ID.
        `newAssignee` - The username to assign the newly moved artifact to.
      Returns:
        New artifact data object
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the sessionId is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when permission is denied for the specified operation.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object is invalid.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - when an invalid argument is passed in.
        `com.collabnet.ce.soap60.fault.PlanningFolderRuleViolationFault` - when planning folder rule is violated
        `RemoteException`
      Since:
        4.2

    - #### moveArtifact2

          Artifact2SoapDO moveArtifact2(String sessionId,
                                        String artifactId,
                                        String targetFolderId,
                                        String newAssignee)
                                 throws RemoteException

      Moves an artifact to a specified target folder.
      Parameters:
        `sessionId` - User session id.
        `artifactId` - ID of artifact to move.
        `targetFolderId` - Target folder ID.
        `newAssignee` - The username to assign the newly moved artifact to.
      Returns:
        New artifact data object
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the sessionId is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when permission is denied for the specified operation.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object is invalid.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system error occurs.
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - when an invalid argument is passed in.
        `com.collabnet.ce.soap60.fault.PlanningFolderRuleViolationFault` - when planning folder rule is violated
        `RemoteException`
      Since:
        8.0

    - #### deleteArtifact

          void deleteArtifact(String sessionId,
                              String artifactId)
                       throws RemoteException

      Deletes an artifact.
      Parameters:
        `sessionId` - User session id.
        `artifactId` - Artifact id.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system level error occurs.
        `RemoteException`
      Since:
        4.1

    - #### getAllowedWorkflowTransitionList

          WorkflowTransitionSoapList getAllowedWorkflowTransitionList(String sessionId,
                                                                      String trackerId)
                                                               throws RemoteException

      Deprecated. in favor of getAllowedWorkflowTransitionList2
      Gets workflow transitions for the tracker.
      Change History
      Version 4.4 SP 1
      - Added the missing [new artifact] transitions to the list
      - The returning list now will contain [new artifact] transition list with the following format [from value] [to value] null open null close null pending
      Parameters:
        `sessionId` - User session id.
        `trackerId` - Tracker id.
      Returns:
        Workflow definitions list. For requiredFields property of workflow definition, following special field IDs are used (in addition to standard field definitions in ArtifactSoapDO): "comment", "attachment", "assignedTo", "priority".
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.SystemFault` - when ...
        `RemoteException`
      Since:
        4.3

    - #### getAllowedWorkflowTransitionList2

          WorkflowTransition2SoapList getAllowedWorkflowTransitionList2(String sessionId,
                                                                        String trackerId)
                                                                 throws RemoteException

      Deprecated. in favor of getAllowedWorkflowTransitionList3
      Gets workflow transitions for the tracker.
      Change History
      Version 17.8
      - Added 'hiddenFields' info to transition data
      Version 4.4 SP 1
      - Added the missing [new artifact] transitions to the list
      - The returning list now will contain [new artifact] transition list with the following format [from value] [to value] null open null close null pending
      Parameters:
        `sessionId` - User session id.
        `trackerId` - Tracker id.
      Returns:
        Workflow definitions list. For requiredFields and hiddenFields properties of workflow definition, following special field IDs are used (in addition to standard field definitions in ArtifactSoapDO): "comment", "attachment", "assignedTo", "priority".
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.SystemFault` - when ...
        `RemoteException`
      Since:
        17.8

    - #### copyWorkflowTransitions

          void copyWorkflowTransitions(String sessionId,
                                       String srcTrackerId,
                                       String dstTrackerId)
                                throws RemoteException

      Copies workflow transitions between two trackers.

      In order for this operation to succeed, the following conditions must be met: - caller needs to have tracker admin permission for both srTracker and destTracker - every transition req role in srcTracker must have corresponding role with the same name in dstTracker - every transition req field in srcTracker must have corresponding field with the same name in dstTracker or be a custom field name.

      Parameters:
        `sessionId` - User session id.
        `srcTrackerId` - Tracker id.
        `dstTrackerId` - Tracker id.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.WorkflowViolationFault` - when the copy of workflow transition cannot be completed
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system level error occurs.
        `RemoteException`
      Since:
        4.3-SP1-HOTFIX3

    - #### cloneTracker

          Tracker2SoapDO cloneTracker(String sessionId,
                                      String srcTrackerId,
                                      String destTrackerTitle,
                                      String destTrackerDescription)
                               throws RemoteException

      Clone Tracker within the same project
      Parameters:
        `sessionId` - User session id.
        `srcTrackerId` - Tracker id.
        `destTrackerTitle` - destination Tracker tile
        `destTrackerDescription` - destination Tracker description
      Returns:
        returns cloned Tracker
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.ObjectAlreadyExistsFault` - if an existing tracker already exists.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system level error occurs.
        `RemoteException`
      Since:
        8.0

    - #### cloneTrackerAcrossProject

          Tracker2SoapDO cloneTrackerAcrossProject(String sessionId,
                                                   String srcTrackerId,
                                                   String destProjectId,
                                                   String destTrackerTitle,
                                                   String destTrackerDescription)
                                            throws RemoteException

      Clone Tracker across the project
      Parameters:
        `sessionId` - User session id.
        `srcTrackerId` - Tracker id.
        `destProjectId` - on which project you need to create a tracker
        `destTrackerTitle` - destination tracker title
        `destTrackerDescription` - destination tracker description
      Returns:
        returns cloned tracker
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.ObjectAlreadyExistsFault` - if an existing tracker already exists.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system level error occurs.
        `RemoteException`
      Since:
        8.0

    - #### createArtifactDependency

          void createArtifactDependency(String sessionId,
                                        String originId,
                                        String targetId,
                                        String desc)
                                 throws RemoteException

      Creates an artifact dependency between two artifacts. If an existing artifact dependency already exists, the descriptions are simply overridden.
      Parameters:
        `sessionId` - User session id.
        `originId` - Origin artifact id.
        `targetId` - Target artifact id.
        `desc` - Description for the dependency.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.WorkflowViolationFault` - when the copy of workflow transition cannot be completed
        `com.collabnet.ce.soap60.fault.DependencyViolationFault` - when the creation of the dependency causes violation
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system level error occurs.
        `RemoteException`
      Since:
        4.4

    - #### removeArtifactDependency

          void removeArtifactDependency(String sessionId,
                                        String originId,
                                        String targetId)
                                 throws RemoteException

      Removes an artifact dependency between two artifacts.
      Parameters:
        `sessionId` - User session id.
        `originId` - Origin artifact id.
        `targetId` - Target artifact id.
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.WorkflowViolationFault` - when the copy of workflow transition cannot be completed
        `com.collabnet.ce.soap60.fault.DependencyViolationFault` - when the creation of the dependency causes violation
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system level error occurs.
        `com.collabnet.ce.soap60.fault.NoSuchRelationshipFault` - when ...
        `RemoteException`
      Since:
        4.4

    - #### setArtifactRank

          void setArtifactRank(String sessionId,
                               String planningFolderId,
                               String artfToRankId,
                               String artfBeforeId,
                               String artfAfterId)
                        throws RemoteException

      Sets the rank of an artifact relative to one or more other artifacts, in the context of a specific planning folder.

      If two artifacts are specified for artfBeforeId and artfAfterId, then the moved artifact is placed between them. If only artfBeforeId is specified, the moved artifact is placed after it; if only artfAfterId, the moved artifact is moved before it.

      The ranking will be invalid if it doesn't respect certain rules:

      - artifacts cannot be ranked relative to other artifacts unless at least one of the following is true:

      1. they are children of the same parent
      2. they appear at the top level in the planning folder view, i.e. do not have a parent in the specified planning folder.

      - all specified artifacts must belong to the same project as the specified planning folder.

      As of TeamForge 5.4, this operation requires the Planning Folder Admin permission; edit permission on the trackers involved is not sufficient. In the future, a distinct role permission for rank operations may be defined.

      Parameters:
        `sessionId` - User session id.
        `planningFolderId` - the id of the planning folder in which we are doing the rank
        `artfToRankId` - the artifact to rank
        `artfBeforeId` - the artifact that should be before it
        `artfAfterId` - the artifact that should be after it
      Throws:
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when one of the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - when the specified id is invalid.
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system level error occurs.
        `com.collabnet.ce.soap60.fault.InvalidRankFault` - when the requested rank operation is invalid
        `RemoteException`
      Since:
        5.4

    - #### getChildDependencyList

          ArtifactDependencySoapList getChildDependencyList(String sessionId,
                                                            String artifactId)
                                                     throws RemoteException

      Gets the dependency list for an artifact where the artifact is the origin artifact.
      Parameters:
        `sessionId` - User session id.
        `artifactId` - Artifact id.
      Returns:
        dependency list
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.WorkflowViolationFault` - when the copy of workflow transition cannot be completed
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system level error occurs.
        `RemoteException`
      Since:
        4.4

    - #### getParentDependencyList

          ArtifactDependencySoapList getParentDependencyList(String sessionId,
                                                             String artifactId)
                                                      throws RemoteException

      Gets the dependency list for an artifact where the artifact is the target artifact. While in 5.3, an artifact can only have a single parent, that can be changed in future releases.
      Parameters:
        `sessionId` - User session id.
        `artifactId` - Artifact id.
      Returns:
        dependency list
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - when the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.WorkflowViolationFault` - when the copy of workflow transition cannot be completed
        `com.collabnet.ce.soap60.fault.SystemFault` - when an unexpected system level error occurs.
        `RemoteException`
      Since:
        4.4

    - #### reorderTrackers

          void reorderTrackers(String sessionId,
                               String[] trackerIds)
                        throws RemoteException

      Sets a new order of the trackers within a project. The trackers will be listed in this new order in UI and in the methods that list the trackers in the SOAP calls.
      Parameters:
        `sessionId` - User session id.
        `trackerIds` - An array of the tracker ids in their new order. All the tracker ids must belong to the same project
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - When the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - When any of the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - When the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.SystemFault` - When an unexpected system level error occurs.
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - If invalid argument value is passed.
        `RemoteException`
      Since:
        5.4

    - #### getUnitsByProject

          TrackerUnitSoapList getUnitsByProject(String sessionId,
                                                String projectId)
                                         throws RemoteException

      Gets the units for a given project.
      Parameters:
        `sessionId` - User session id.
        `projectId` - The id of the project to retrieve the units
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - When the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - When any of the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.PermissionDeniedFault` - When the user has insufficient privileges.
        `com.collabnet.ce.soap60.fault.SystemFault` - When an unexpected system level error occurs.
        `com.collabnet.ce.soap60.fault.IllegalArgumentFault` - If invalid argument value is passed.
        `RemoteException`
      Since:
        6.2

    - #### getAllowedWorkflowTransitionList3

          WorkflowTransition3SoapList getAllowedWorkflowTransitionList3(String sessionId,
                                                                        String trackerId)
                                                                 throws RemoteException

      Gets workflow transitions for the tracker.
      Change History
      Version 17.11
      - Added 'autoPopulateData' info to transition data
      Version 4.4 SP 1
      - Added the missing [new artifact] transitions to the list
      - The returning list now will contain [new artifact] transition list with the following format [from value] [to value] null open null close null pending
      Parameters:
        `sessionId` - User session id.
        `trackerId` - Tracker id.
      Returns:
        Workflow definitions list. For requiredFields, hiddenFields and autoPopulateData properties of workflow definition, following special field IDs are used (in addition to standard field definitions in ArtifactSoapDO): "comment", "attachment", "assignedTo", "priority".
      Throws:
        `com.collabnet.ce.soap60.fault.InvalidSessionFault` - when the specified session id is invalid.
        `com.collabnet.ce.soap60.fault.NoSuchObjectFault` - when the specified object id is invalid.
        `com.collabnet.ce.soap60.fault.SystemFault` - when ...
        `RemoteException`
      Since:
        17.11

Copyright © 2019 CollabNet. All rights reserved.